package com.lc.day10.tes1;

/**
 * ClassName: Communication
 * Package: com.lc.day10.tes1
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/26 20:58
 * @Version 1.0
 */
class Communication implements Runnable {
    int i = 1;
    public void run() {
        while (true) {
            synchronized (this) {
                notify();
                if (i <= 100) {
                    System.out.println(Thread.currentThread().getName() + ":" + i++);
                } else
                    break;
                try {
                    wait();
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    public static void main(String[] args) {
        Communication communication = new Communication();

        Thread thread1 = new Thread(communication);
        Thread thread2 = new Thread(communication);

        thread1.start();
        thread2.start();
    }
}
