package com.lc.day10.test;

/**
 * ClassName: DeadLockTest
 * Package: com.lc.day10.test
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/26 20:43
 * @Version 1.0
 */
public class DeadLockTest {
    public static void main(String[] args) {

        StringBuilder s1 = new StringBuilder("进入s1锁");
        StringBuilder s2 = new StringBuilder("进入s2锁");

        new Thread() {
            public void run() {
                synchronized (s1) {
                    System.out.println(s1);
                    try {
                        Thread.sleep(10);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    synchronized (s2) {
                        System.out.println(s2);
                    }
                }
            }
        }.start();

        new Thread() {
            public void run() {
                synchronized (s2) {
                    System.out.println(s2);
                    try {
                        Thread.sleep(10);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    synchronized (s1) {
                        System.out.println(s1);
                    }

                }
            }
        }.start();
    }
}
