package com.lc.day10.test;

import org.junit.Test;

/**
 * ClassName: Test01
 * Package: com.lc.day10.test
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/26 20:30
 * @Version 1.0
 */
public class Test01 {

    static LazyOne s1;
    static LazyOne s2;

    public static void main(String[] args) {

        Thread t1 = new Thread(){
            public void run(){
                s1 = LazyOne.getInstance1();
            }
        };
        Thread t2 = new Thread(){
            public void run(){
                s2 = LazyOne.getInstance1();
            }
        };

        t1.start();
        t2.start();

        try {
            t1.join();
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        System.out.println(s1);
        System.out.println(s2);
        System.out.println(s1 == s2);
    }
}
