package com.lc.day10.thowable1;

import org.junit.Test;

import java.util.Scanner;

/**
 * ClassName: Test06_try
 * Package: com.lc.day10.thowable1
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/25 10:37
 * @Version 1.0
 */
public class Test10_throws {
    //参数异常

    @Test
    public void test02() {
        Scanner scanner = new Scanner(System.in);

        scanner.close();
    }

    @Test
    public void test01() {
        try {
            int max = max1();
            System.out.println(max);
        } catch (IllegalAccessException e) {
            throw new RuntimeException(e);
            //System.out.println("123");
        }
    }

    public int  max1( int ... a ) throws IllegalAccessException {

        int max = 0;
        //健壮性
        if ( a == null || a.length == 0 ){
            //message 提示信息
            throw new IllegalAccessException("长度不能为0，也不能是null对象");
        }
        for (int i = 0; i < a.length; i++) {
            if ( a[i] > max  ){
                max = a[i];
            }
        }

        return max;
    }

    //比较大小
    public int  max( int ... a ){

        int max = 0;
        try {
            //健壮性
            if ( a == null || a.length == 0 ){
                //message 提示信息
                throw new IllegalAccessException("长度不能为0，也不能是null对象");
            }

            for (int i = 0; i < a.length; i++) {
                if ( a[i] > max  ){
                    max = a[i];
                }
            }

        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
        return max;
    }


}
