package com.lc.day11.test5;

import java.util.concurrent.*;

/**
 * ClassName: ThreadPool
 * Package: com.lc.day11.test5
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/27 21:08
 * @Version 1.0
 */
public class ThreadPool {

    public static void main(String[] args) throws ExecutionException, InterruptedException {

        String str = null;
        StringBuffer sb = new StringBuffer();
        sb.append(str);

        System.out.println(sb.length());//

        System.out.println(sb);//

        StringBuffer sb1 = new StringBuffer(null);
        System.out.println(sb1);//

        ExecutorService executorService = Executors.newFixedThreadPool(10);

        ThreadPoolExecutor threadPoolExecutor = (ThreadPoolExecutor) executorService;
        threadPoolExecutor.setMaximumPoolSize(50);
        executorService.execute(new NumberThread1());

        Future future = executorService.submit(new NumberThread3());//适合使用于Callable
        System.out.println("总和为：" + future.get());

        executorService.shutdown();


        ThreadPoolExecutor threadPoolExecutor1 = new ThreadPoolExecutor(3,2,10,TimeUnit.HOURS,new ArrayBlockingQueue<>(2));
    }
}
class NumberThread1 implements Runnable{

    @Override
    public void run() {
        for(int i = 0;i <= 100;i++){
            if(i % 2 == 0){
                System.out.println(Thread.currentThread().getName() + ": " + i);
            }
        }
    }
}

class NumberThread2 implements Runnable{

    @Override
    public void run() {
        for(int i = 0;i <= 100;i++){
            if(i % 2 != 0){
                System.out.println(Thread.currentThread().getName() + ": " + i);
            }
        }
    }
}

class NumberThread3 implements Callable{

    @Override
    public Object call() throws Exception {
        int sum = 0;
        for (int i = 0; i < 100; i++) {
            if (i %2 == 0){
                sum+=i;
            }
        }
        return sum;
    }
}
