package com.lc.day11.thread4;

/**
 * ClassName: TicketRunable
 * Package: com.lc.day11.thread3
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/27 14:36
 * @Version 1.0
 */
public class TicketRunable implements Runnable{

    int ticket = 100; // 类

    public synchronized void saleOne(){ //this
        if (ticket > 0){
            System.out.println(Thread.currentThread().getName()+"-卖"+ticket);
            ticket--;
        }
    }

    @Override
    public void run() {
        while (ticket > 0){
            //暴露问题  线程1  线程2  停滞
            try {
                Thread.sleep(10);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            saleOne();
        }
    }
}
