package com.lc.day12.thread2;

/**
 * ClassName: Product
 * Package: com.lc.day12.thread2
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/28 10:05
 * @Version 1.0
 */
public class Product {

    int number = 0;

    public static final int MAX = 20;
    public static final int MIN = 1;


    //添加
    public synchronized void addProduct(){
        if (number < MAX ){
            number++;
            System.out.println(Thread.currentThread().getName()+"产品数量:"+number);
            //唤醒
            notifyAll();
        }else {
            try {
                wait();
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }
    }
    //减少
    public synchronized void subProduct(){
        if (number > MIN ){
            number--;
            System.out.println(Thread.currentThread().getName()+"产品数量:"+number);
            //唤醒
            notifyAll();
        }else {
            try {
                wait();
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }
    }


}
