package com.lc.day10.test;

/**
 * ClassName: LazyOne
 * Package: com.lc.day10.test
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/26 20:26
 * @Version 1.0
 */
public class LazyOne {
    private static LazyOne instance;

    private LazyOne(){}

    //方式1：
    public static LazyOne getInstance1(){

        if(instance == null){
            try {
                Thread.sleep(100);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            instance = new LazyOne();
        }
        return instance;
    }

    public static  LazyOne getInstance2(){
        synchronized (LazyOne.class){
            if(instance == null){
                instance = new LazyOne();
            }
            return instance;
        }
    }

}
