package com.lc.day10.test;

import java.awt.*;
import java.util.concurrent.locks.ReentrantLock;

/**
 * ClassName: TicketRujable
 * Package: com.lc.day10.test
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/26 20:51
 * @Version 1.0
 */
public class TicketRujable implements Runnable{

    private final static ReentrantLock lock = new ReentrantLock();
    int ticket = 100;
    @Override
    public void run() {

        while (true){
            try {
                lock.lock();
                if(ticket > 0){
                    try {
                        Thread.sleep(10);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    System.out.println(ticket--);
                }else{
                    break;
                }
            } finally {
                lock.unlock();
            }
        }
    }

    public static void main(String[] args) {

        TicketRujable ticketRujable = new TicketRujable();

        Thread t1 = new Thread(ticketRujable);
        Thread t2 = new Thread(ticketRujable);

        t1.start();
        t2.start();

    }
}
