package com.lc.day10.thowable1;

import org.junit.Test;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Scanner;

/**
 * ClassName: Test04
 * Package: com.lc.day10.thowable1
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/25 10:14
 * @Version 1.0
 */
public class Test05 {
    //异常处理 两种方法
    @Test
    public void test06() {
        // 编译
        // 提示
        try {
            //线程
            Thread.sleep(5000);//休眠1秒  InterruptedException 中断异常

            System.out.println("hello");
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

    @Test
    public void test07(){
        try {
            Class c = Class.forName("java.xxx.String");//ClassNotFoundException
        } catch (ClassNotFoundException e) {
           // throw new RuntimeException(e); //异常信息注释
            e.printStackTrace();
        }
        System.out.println("hello");
    }

    @Test
    public void test08() throws SQLException {
        Connection conn = DriverManager.getConnection("....");  //SQLException
    }
    @Test
    public void test09() throws FileNotFoundException {
        FileInputStream fis = new FileInputStream("陈哥Java秘籍.txt");
        //FileNotFoundException
    }
    @Test
    public void test10() {
        try {
            File file = new File("陈哥Java秘籍.txt");
            FileInputStream fis = new FileInputStream(file);//FileNotFoundException
            int b = fis.read();//IOException
            while(b != -1){
                System.out.print((char)b);
                b = fis.read();//IOException
            }

            fis.close();//IOException
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
    //说几个常见的异常  

}
