package com.lc.day10.thowable1.exer2;

/**
 * ClassName: Triangle
 * Package: com.lc.day10.thowable1.exer2
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/25 15:25
 * @Version 1.0
 */
public class Triangle {

    private Integer a;
    private Integer b;
    private Integer c;

    public Triangle(Integer a, Integer b, Integer c) {

        if (a < 0 || b < 0 || c < 0){
            throw new NotTriangleException("边长不能小于0");
        }

        if (a + b <= c || a + c <= b || c + b <= a){
            throw new NotTriangleException("两边之和必须大于第三边");
        }

        this.a = a;
        this.b = b;
        this.c = c;
    }


    @Override
    public String toString() {
        return "Triangle{" +
                "a=" + a +
                ", b=" + b +
                ", c=" + c +
                '}';
    }
}
