package com.lc.day11.thread4;

/**
 * ClassName: WindowTicket
 * Package: com.lc.day11.thread3
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/27 14:24
 * @Version 1.0
 */
public class WindowTicket extends Thread {
    //共享 static
    static int ticket = 100;

    //售票方法
    public static synchronized void saleOne(){
        if ( ticket > 0 ){

            System.out.println(Thread.currentThread().getName()+"---"+"正在卖"+ticket);

            ticket--;
        }
    }

    @Override
    public void run() {
        while ( ticket > 0 ){
            try {
                Thread.sleep(10);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            saleOne();
        }
    }
}
