package com.lc.day11.thread5;

/**
 * ClassName: LazyOne
 * Package: com.lc.day11.thread5
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/27 16:43
 * @Version 1.0
 */
public class TestLazyOne {

    static LazyOne instance1;
    static LazyOne instance2;

    public static void main(String[] args) {

        Thread thread1 = new Thread() {
            @Override
            public void run() {
                instance1 = LazyOne.getInstance1();
            }
        };

        Thread thread2 = new Thread() {
            @Override
            public void run() {
                instance2 = LazyOne.getInstance1();
            }
        };

        try {
            thread1.start();
            thread2.start();

            thread1.join();
            thread2.join();
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }

        System.out.println(instance1 == instance2);
    }
}
