package com.lc.day12.string4;

import org.junit.Test;

/**
 * ClassName: Test01
 * Package: com.lc.day12.string4
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/28 14:07
 * @Version 1.0
 */
public class Test01 {


    @Test
    public void test05(){
        String str = "hello";
        String str2 = "world";
        String str3 ="helloworld";

        String str4 = "hello".concat("world");
        String str5 = "hello"+"world";

        System.out.println(str3 == str4);//
        System.out.println(str3 == str5);//
    }
    @Test
    public void test04(){
        String s1 = "hello";
        String s2 = "world";
        String s3 = "helloworld";

        String s4 = (s1 + "world").intern();// 常量池
        String s5 = (s1 + s2).intern();

        System.out.println(s3 == s4);//
        System.out.println(s3 == s5);//
    }

    @Test
    public void test03(){
        String s1 = "hello";
        String s2 = "world";
        String s3 = "hello" + "world";  //常量池
        String s4 = s1 + "world";  //堆
        String s5 = s1 + s2;  //堆
        String s6 = (s1 + s2).intern(); //常量池
        System.out.println(s3 == s4); // false
        System.out.println(s3 == s5); // false
        System.out.println(s4 == s5); // false
        System.out.println(s3 == s6); // true
    }

    @Test
    public void test02(){
        Person p1 = new Person();
        p1.name = "Tom";

        Person p2 = new Person();
        p2.name = "Tom";

        System.out.println(p1.name.equals( p2.name)); //  true 比较内容
        System.out.println(p1.name == p2.name); // true
        System.out.println(p1.name == "Tom"); // true


        String s1 = "javaEE"; //指向常量池
        String s2 = "javaEE";
        String s3 = new String("javaEE"); //指向堆
        String s4 = new String("javaEE");

        System.out.println(s1 == s2);//  true
        System.out.println(s1 == s3);//  false
        System.out.println(s1 == s4);//  false
        System.out.println(s3 == s4);//  false
    }

    @Test
    public void test01(){

        //123 在常量池中
        String str = "123";


        String s1 = "hello";
        String s2 = "hello";
        System.out.println(s1 == s2); //
    }

}
