package com.lc.day12.thread3;

import java.util.concurrent.*;

/**
 * ClassName: Test01
 * Package: com.lc.day12.thread3
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/28 11:19
 * @Version 1.0
 */
public class Test02 {

    public static void main(String[] args) throws ExecutionException, InterruptedException {
        //创建线程池
        ExecutorService executorService = Executors.newFixedThreadPool(5);

        //Runable 子类
        MyRunable myRunable = new MyRunable();

        //执行
        executorService.execute(myRunable);


        //callable
        SumNumber sumNumber = new SumNumber();

        Future submit = executorService.submit(sumNumber);

        //获取结果
        Object o = submit.get();
        System.out.println(o);

        executorService.shutdown();

        //手动创建线程池
        ThreadPoolExecutor threadPoolExecutor = new ThreadPoolExecutor(3, 2, 3, TimeUnit.SECONDS, null);


    }
}
